<template>
  <div class="app-container">
    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="存放地名称" prop="posName" label-width="100">
        <el-input v-model="queryParams.posName" placeholder="请输入存放地名称" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item label="存放地地址" prop="address" label-width="100">
        <el-input v-model="queryParams.address" placeholder="请输入存放地地址" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item label="存放类型" prop="depositType" label-width="60">
        <el-select v-model="queryParams.depositType" placeholder="请选择存放类型" clearable size="small">
          <el-option v-for="dict in this.getDictDatas(DICT_TYPE.COMPANY_DEPOSIT_TYPE)" :key="dict.value"
            :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="openForm(undefined)"
          v-hasPermi="['company:property-pos:create']">新增</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
      <el-table-column label="序号" align="center" prop="num">
        <template slot-scope="scope">
          <span style="margin-left: 10px">{{ queryParams.pageSize * (queryParams.pageNo - 1) + scope.$index + 1
            }}</span>
        </template>
      </el-table-column>
      <el-table-column label="所属企业" align="center" prop="corpName" />
      <el-table-column label="存放地名称" align="center" prop="posName" />
      <el-table-column label="存放地地址" align="center" prop="address" />
      <el-table-column label="面积(㎡)" align="center" prop="area" />
      <el-table-column label="存放类型" align="center" prop="depositType">
        <template v-slot="scope">
          <dict-tag :type="DICT_TYPE.COMPANY_DEPOSIT_TYPE" :value="scope.row.depositType" />
        </template>
      </el-table-column>
      <el-table-column fixed="right" label="操作" align="center" class-name="small-padding fixed-width" width="200">
        <template v-slot="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="openForm(scope.row.id)"
            v-hasPermi="['company:property-pos:update']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
            v-hasPermi="['company:property-pos:delete']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
      @pagination="getList" />
    <!-- 对话框(添加 / 修改) -->
    <PropertyPosForm ref="formRef" @success="getList" />
  </div>
</template>

<script>
import * as PropertyPosApi from '@/api/company/property/position';
import PropertyPosForm from './PropertyPosForm.vue';
export default {
  name: "PropertyPos",
  components: {
    PropertyPosForm,
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 企业管理-资产存放位置列表
      list: [],
      // 是否展开，默认全部展开
      isExpandAll: true,
      // 重新渲染表格状态
      refreshTable: true,
      // 选中行
      currentRow: {},
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        posName: null,
        address: null,
        depositType: null,
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询列表 */
    async getList() {
      try {
        this.loading = true;
        const res1 = await PropertyPosApi.getPropertyPosList();
        const res = await PropertyPosApi.getPropertyPosPage(this.queryParams);
        this.list = res.data.records;
        this.total = res.data.total;
      } finally {
        this.loading = false;
      }
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 添加/修改操作 */
    openForm(id) {
      this.$refs["formRef"].open(id);
    },
    /** 删除按钮操作 */
    async handleDelete(row) {
      const id = row.id;
      await this.$modal.confirm('是否确认删除数据?')
      try {
        await PropertyPosApi.deletePropertyPos(id);
        await this.getList();
        this.$modal.msgSuccess("删除成功");
      } catch { }
    },
    /** 导出按钮操作 */
    async handleExport() {
      await this.$modal.confirm('是否确认导出所有资产存放位置数据项?');
      try {
        this.exportLoading = true;
        const data = await PropertyPosApi.exportPropertyPosExcel(this.queryParams);
        this.$download.excel(data, '企业管理-资产存放位置.xls');
      } catch {
      } finally {
        this.exportLoading = false;
      }
    },
  }
};
</script>
